
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% logic.m
% 6/1/01
% 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [out1,out2,out3]=lec7Logic(t,x,flag);

global Q;

if (nargin < 3 | isempty(flag))         % if < 3 inputs or if flag is empty
  if Q == 1
    out1 = lec7A1(t,x);		% calculate derivative of state
  elseif Q == 2
    out1 = lec7A2(t,x); 		% calculate derivative of state
  end

else                                    % if there is flag, then see cases
  switch flag
  case 'events'                         % return VALUE, ISTERMINAL, DIRECTION

  epsilon = 1e-3;

    if Q == 1 
      if ( x(1)*x(2) >= 0 )
        out1 = 1; 			% no event when out1 = 1
      else
  	out1 = 0;			% event: leaves when enters Inv_coop 
      end;

    elseif Q == 2
      if ( x(1)*x(2) <= 0 ) 
      	out1 = 1;			% no event when out1 = 1
      else 
	out1 = 0;			% event: leaves when close to Vnbs 
      end;

    end;

  out2 = [1]';				% don't stop integrating == 0
  out3 = [0]';				% decreasing or increasing both OK

  otherwise
    error(['unknown flag ''' flag '''.']);
  end
end


